package io;

import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.Vector;

import io.core.agents.AgentFactory;

public class UserInterface extends Thread {
	public static void main(String[] arguments) {
		new UserInterface().start();
	}

	public void run() {
		BufferedReader inStream;
		String currentLine;

		inStream = new BufferedReader( new InputStreamReader(System.in) );

		System.err.println("Welcome to IO's user interface!");
		System.err.println("\tType quit to quit this theater.");
		System.err.println("\tType join <name server> to join a computation by that and currently known nameserver(s).");
		System.err.println("\tType join to join a computation using currently known nameserver(s).");
		System.err.println("\tType leave to leave your computation(s).");
		System.err.flush();

		try {
			while ( !(currentLine = inStream.readLine()).equals("quit") ) {
				if (currentLine.length() >= 4) {
					if (currentLine.equals("join")) {
						AgentFactory.getProtocol().joinComputation(null);
					} else if (currentLine.substring(0,4).equals("join")) {
						Vector peerServers = new Vector();
						peerServers.add(currentLine.substring(5));
						AgentFactory.getProtocol().joinComputation(peerServers);					
					} else if (currentLine.equals("leave")) {
						System.err.println("leaving computation");
						System.err.flush();
						AgentFactory.getProtocol().leaveComputation();
					}
				}
			}
		} catch (IOException e) {
			System.err.println("Error in IO");
			e.printStackTrace();
		}

		System.err.println("Exiting the IO network.");
		System.exit(0);
	}
}
