package io.ars.protocol;

import io.core.protocol.IOPacket;
import io.core.protocol.TheaterLocator;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.net.UnknownHostException;


public class ComputingCheck extends IOPacket {

	public ComputingCheck() {
	}

	public ComputingCheck(TheaterLocator _theaterLocator) {
		setOrigin(_theaterLocator);
	}


	public Boolean getResponse(TheaterLocator theaterLocator) throws IOException, UnknownHostException, ClassNotFoundException {
		Boolean retVal = new Boolean(false);

		//Connect to the given Theater;
		Socket theaterConnection = new Socket(theaterLocator.getHost(), theaterLocator.getPort());
		ObjectOutputStream out = new ObjectOutputStream(new BufferedOutputStream(theaterConnection.getOutputStream()));
		//write the packet to the connection, then close it
		out.writeObject(new ComputingCheck(getOrigin()));
		out.flush();

		ObjectInputStream in = new ObjectInputStream(new BufferedInputStream(theaterConnection.getInputStream()));
		retVal = (Boolean)in.readObject();
		in.close();
		out.close();
		theaterConnection.close();

		return retVal;
	}
}
