package io.core.language;

import salsa.language.Actor;
import salsa.language.Message;
import salsa.naming.UAN;

import io.core.agents.AgentFactory;
import io.core.agents.ProfilingAgent;

public class AutonomousActor extends Actor {
	private transient ProfilingAgent profilingAgent;

	public AutonomousActor() {
		super();

		profilingAgent = AgentFactory.getProfiling();
		profilingAgent.actorEnter(getIdentifier());
	}

	private String getIdentifier() {
		if (__uan == null)	return __ual.toString();
		else			return __uan.toString();
	}

	public synchronized void bind(UAN uan) {
		profilingAgent.updateIdentifier(uan.toString(), __ual.toString());
	}

	public synchronized void send(Message message) {
		profilingAgent.received(getIdentifier(), message);
		super.send(message);
	}

	public void process(Message message) {
		AgentFactory.getProfiling().beginProcessed(getIdentifier());
		super.process(message);
		AgentFactory.getProfiling().endProcessed(getIdentifier());
	}

	private void writeObject(java.io.ObjectOutputStream out) throws Exception {
		profilingAgent.actorExit(getIdentifier());
		out.defaultWriteObject();
	}

	private void readObject(java.io.ObjectInputStream in) throws Exception {
		in.defaultReadObject();

		profilingAgent = AgentFactory.getProfiling();
		profilingAgent.actorEnter(getIdentifier());
	}
}
