package salsac;
public class MessageSendingData {
    String sender;
    String target;
    String targets;
    String methodNames;
    String arguments;
    String tokens;
    String tokenClass;
    boolean firstClass = false;

    MessageSendingData(){}

    MessageSendingData(String arguments,
		       String tokens){
	this.arguments = arguments;
	this.tokens = tokens;
    }

    MessageSendingData(String sender,
		       String target,
		       String targets,
		       String methodNames,
		       String arguments,
		       String tokens){
	this(arguments, tokens);
	this.sender = sender;
	this.target = target;
	this.targets = targets;
	this.methodNames = methodNames;
    }

    MessageSendingData(String sender,
		       String target,
		       String targets,
		       String methodNames,
		       String arguments,
		       String tokens,
		       String tokenClass){
	this(sender, target, targets, methodNames, arguments, tokens);
	this.tokenClass = tokenClass;
    }

    void setFirstClass() {
      firstClass = true;
    }

    String getSender(){ return sender; }
    String getTarget(){ return target; }
    String getTargets(){ return targets; }
    String getMethodNames(){ return methodNames; }
    String getArguments(){ return arguments; }
    String getTokens(){	return tokens; }
    String getTokenClass(){ return tokenClass; }
    boolean getFirstClass(){ return firstClass; }

    void setTarget(String target) { this.target = target; }
    void setTokenClass(String tokenClass) { this.tokenClass = tokenClass; }

    void append(MessageSendingData msd){
	sender = (sender == null? msd.getSender() : sender);
	target = (target == null? msd.getTarget() : target);
	targets = (targets == null? msd.getTargets() : targets + ", " + msd.getTargets());
	methodNames = (methodNames == null? msd.getMethodNames() : methodNames + ", " + msd.getMethodNames());
	arguments = (arguments == null? msd.getArguments() : arguments + ", " + msd.getArguments());
	tokens = (tokens == null? msd.getTokens() : tokens + ", " + msd.getTokens());
	tokenClass = (tokenClass == null? msd.getTokenClass() : tokenClass);

	if (!firstClass) firstClass = msd.getFirstClass();
    }
}
